Index: trunk/org.gvsig.app.document.layout2.app/org.gvsig.app.document.layout2.app.mainplugin/src/main/java/org/gvsig/app/extension/reportfromlayout/ExportReportToLayout.java
===================================================================
--- trunk/org.gvsig.app.document.layout2.app/org.gvsig.app.document.layout2.app.mainplugin/src/main/java/org/gvsig/app/extension/reportfromlayout/ExportReportToLayout.java	(revision 1607)
+++ trunk/org.gvsig.app.document.layout2.app/org.gvsig.app.document.layout2.app.mainplugin/src/main/java/org/gvsig/app/extension/reportfromlayout/ExportReportToLayout.java	(revision 1608)
@@ -9,7 +9,6 @@
 import java.awt.event.ActionEvent;
 import java.io.File;
 import java.io.FileOutputStream;
-import java.io.InputStream;
 import java.util.List;
 import java.util.function.Predicate;
 import javax.json.JsonObject;
@@ -19,10 +18,9 @@
 import javax.swing.event.ChangeEvent;
 import javax.swing.event.TreeSelectionEvent;
 import org.apache.commons.io.IOUtils;
-import org.apache.commons.lang3.StringUtils;
 import org.gvsig.app.ApplicationLocator;
 import org.gvsig.app.project.documents.layout.LayoutManager;
-import org.gvsig.app.project.documents.layout.report.LayoutReportActionImpl;
+import org.gvsig.app.project.documents.layout.report.LayoutReportAction;
 import org.gvsig.app.project.documents.layout.report.LayoutReportActionFactory;
 import org.gvsig.fmap.dal.feature.FeatureStore;
 import org.gvsig.fmap.dal.swing.DALSwingLocator;
@@ -30,7 +28,6 @@
 import org.gvsig.fmap.dal.swing.report.ReportAction;
 import org.gvsig.fmap.dal.swing.storesrepository.StoresRepositoryController;
 import org.gvsig.i18n.Messages;
-import org.gvsig.json.Json;
 import org.gvsig.tools.ToolsLocator;
 import org.gvsig.tools.dispose.DisposeUtils;
 import org.gvsig.tools.i18n.I18nManager;
@@ -144,60 +141,27 @@
     
     private void fillCboReport() {
         DataSwingManager dataSwingManager = DALSwingLocator.getDataSwingManager();
-        DefaultComboBoxModel<LabeledValue<ReportAction>> model = new DefaultComboBoxModel();
+        DefaultComboBoxModel<LabeledValue<LayoutReportAction>> model = new DefaultComboBoxModel();
         if(this.source == null) {
             this.cboReport.setModel(model);
             return;
         }
-        List<ReportAction> reports = dataSwingManager.getReportActions(source, (Predicate<JsonObject>) (JsonObject t) -> LayoutReportActionFactory.isJsonApplicable(t));
+        List<ReportAction> reports = dataSwingManager.getReportActions(
+                source, 
+                (Predicate<JsonObject>) (JsonObject t) -> LayoutReportActionFactory.isJsonApplicable(t)
+        );
         
         for (ReportAction report : reports) {
-            model.addElement(new LabeledValueImpl<>(report.getReportLabel(), report));
+            model.addElement(new LabeledValueImpl<>(report.getReportLabel(), (LayoutReportAction)report));
         }
         cboReport.setModel(model);
 
     }
   
-//    List<Document> getLayouts() {
-//
-//        List<Document> layouts = ApplicationLocator.getProjectManager().getCurrentProject().getDocuments(LayoutDocument.class);
-//
-//        return layouts;
-//
-//    }
-
-
-    
-//    private void fillCboLayout() {
-//        DefaultComboBoxModel<LabeledValue<LayoutDocument>> model = new DefaultComboBoxModel();
-//        List<Document> layouts = getLayouts();
-//        
-//        if(layouts.size() > 1){
-//            Collections.sort(layouts, new CompareUtils.NullSafeComparator<Document>() {
-//                @Override
-//                public int safeCompare(Document o1, Document o2) {
-//                    return StringUtils.compare(o1.getName(), o2.getName());
-//                }
-//            });
-//        }
-//        
-//        for (Document layout : layouts) {
-//            if(layout instanceof LayoutDocument){
-//                model.addElement(new LabeledValueImpl<>(layout.getName(), (LayoutDocument)layout));
-//            }
-//        }
-//        cboLayout.setModel(model);
-//
-//    }
-    
-    private ReportAction getReportAction(){
-        return (ReportAction) ((LabeledValue)cboReport.getSelectedItem()).getValue();
+    private LayoutReportAction getReportAction(){
+        return (LayoutReportAction) ((LabeledValue)cboReport.getSelectedItem()).getValue();
     }
     
-//    private LayoutDocument getLayoutDocument(){
-//        return (LayoutDocument) ((LabeledValue)cboLayout.getSelectedItem()).getValue();
-//    }
-    
     public void fetch(ExportReportToLayoutParameters params){
         params.setSource(this.source);
         params.setReportAction(this.getReportAction());
@@ -206,7 +170,7 @@
 
     public boolean doExportReportToLayout(ExportReportToLayoutParameters params) {
         FeatureStore source = params.getSource();
-        ReportAction report = params.getReportAction();
+        LayoutReportAction report = params.getReportAction();
         File file = params.getFile();
         ThreadSafeDialogsManager dialogs = ToolsSwingLocator.getThreadSafeDialogsManager();
         I18nManager i18n = ToolsLocator.getI18nManager();
@@ -244,53 +208,15 @@
         
     }
     
-    public boolean doExportReportToLayout(FeatureStore store, ReportAction report, File templateFile) {
+    public boolean doExportReportToLayout(FeatureStore store, LayoutReportAction report, File templateFile) {
         
-
-        ResourcesStorage.Resource resourceReport = null;
         ResourcesStorage.Resource resourceLayout = null;
         FileOutputStream templateOs = null;
         ThreadSafeDialogsManager dialogs = ToolsSwingLocator.getThreadSafeDialogsManager();
         I18nManager i18n = ToolsLocator.getI18nManager();
         try {
-            ResourcesStorage resources = store.getResourcesStorage();
-
-            String resourceReportName = getResourceName(resources, report.getReportName());
-            if (resourceReportName == null) {
-                dialogs.messageDialog(
-                        i18n.getTranslation("_Cant_find_resource_XreportnameX",
-                                new String[]{
-						resourceReportName,
-					}
-                        ),
-                        null,
-                        i18n.getTranslation("_Export_report_to_layout"),
-                        JOptionPane.WARNING_MESSAGE);
-                return false;
-            }
+            resourceLayout = report.getTemplateAsResource();
             
-            resourceReport = resources.getResource(resourceReportName);
-            
-            JsonObject jsonReport = Json.createObject(resourceReport.asInputStream());
-            
-            String templateName = jsonReport.getString(LayoutReportActionImpl.LAYOUT_REPORT_TEMPLATE_NAME, LayoutReportActionImpl.LAYOUT_REPORT_DEFAULT_TEMPLATE_NAME);
-            
-            if(StringUtils.isBlank(templateName)){
-                
-                dialogs.messageDialog(
-                        i18n.getTranslation("_Template_name_is_blank"//,
-//                                new String[]{
-//						resourceReportName,
-//					}
-                        ),
-                        null,
-                        i18n.getTranslation("_Export_report_to_layout"),
-                        JOptionPane.WARNING_MESSAGE);
-                return false;
-            }
-            
-            resourceLayout = resources.getResource(templateName);
-            
             if (!(templateFile.getPath().toLowerCase().endsWith(LayoutManager.TEMPLATE_FILE_POINTEXT.toLowerCase()))) {
                 templateFile = new File(templateFile.getPath() + LayoutManager.TEMPLATE_FILE_POINTEXT);
             }
@@ -308,70 +234,13 @@
             return false;
         } finally {
             IOUtils.closeQuietly(templateOs);
-            IOUtils.closeQuietly(resourceReport);
             IOUtils.closeQuietly(resourceLayout);
         }
         
-        
     }
     
-//    private String getNextResourceName(ResourcesStorage resources, String resourceName){
-//        List<ResourcesStorage.Resource> reports = resources.getResources(resourceName);
-//        if(reports == null || reports.isEmpty()){
-//            return resourceName;
-//        }
-//        int n = -1;
-//        for (ResourcesStorage.Resource report : reports) {
-//            if(StringUtils.contains(report.getName(), resources.getSeparator())){
-//                String[] s = StringUtils.split(report.getName(), resources.getSeparator());
-//                n = Math.max(n, Integer.parseInt(s[0]));
-//            } else {
-//                n=0;
-//            }
-//        }
-//        
-//        if (n < 0) {
-//            return resourceName;
-//        }
-//        
-//        n++;
-//        return String.valueOf(n) + resources.getSeparator() + resourceName;
-//
-//        
-//    }
-//    
-    private String getResourceName(ResourcesStorage resources, String reportName) {
-        try {
-            if (resources != null) {
-                List<ResourcesStorage.Resource> reportsResources = resources.getResources("report");
-                if (reportsResources != null && !reportsResources.isEmpty()) {
-                    for (ResourcesStorage.Resource resource : reportsResources) {
-                        InputStream is = null;
-                        try {
-                            is = resource.asInputStream();
-                            JsonObject json = javax.json.Json.createReader(is).readObject();
-                            String name = json.getString(LayoutReportActionImpl.LAYOUT_REPORT_NAME, null);
-                            if(StringUtils.equalsIgnoreCase(name, reportName)){
-                                return resource.getName();
-                            }
-                        } catch (Exception ex) {
-                            LOGGER.warn("Can't load report form resource (" + resource.getURL() + ")", ex);
-                        } finally {
-                            IOUtils.closeQuietly(is);
-                        }
-                        DisposeUtils.disposeQuietly(resource);
-                    }
-                }
-            }
-        } finally {
-            DisposeUtils.disposeQuietly(resources);
-        }
-        return null;
-    }
-    
-
     private void doChangeReport() {
-        ReportAction report = getReportAction();
+//        ReportAction report = getReportAction();
         this.pickerFile.set(null);
 //        if(report == null){
 //            this.txtIdentifier.setText("");
